def __for_method__OperatorsPseudoSpectral2D__rotfft_from_vecfft(self_KX, self_KY, vecx_fft, vecy_fft):
    """Return the rotational of a vector in spectral space."""
    return 1j * (self_KX * vecy_fft - self_KY * vecx_fft)


__code_new_method__OperatorsPseudoSpectral2D__rotfft_from_vecfft = """

def new_method(self, vecx_fft, vecy_fft):
    return backend_func(self.KX, self.KY, vecx_fft, vecy_fft)

"""


def __for_method__OperatorsPseudoSpectral2D__divfft_from_vecfft(self_KX, self_KY, vecx_fft, vecy_fft):
    """Return the divergence of a vector in spectral space."""
    return 1j * (self_KX * vecx_fft + self_KY * vecy_fft)


__code_new_method__OperatorsPseudoSpectral2D__divfft_from_vecfft = """

def new_method(self, vecx_fft, vecy_fft):
    return backend_func(self.KX, self.KY, vecx_fft, vecy_fft)

"""


def __for_method__OperatorsPseudoSpectral2D__vecfft_from_rotfft(self_KX_over_K2, self_KY_over_K2, rot_fft):
    """Return the velocity in spectral space computed from the
        rotational."""
    ux_fft = 1j * self_KY_over_K2 * rot_fft
    uy_fft = -1j * self_KX_over_K2 * rot_fft
    return (ux_fft, uy_fft)


__code_new_method__OperatorsPseudoSpectral2D__vecfft_from_rotfft = """

def new_method(self, rot_fft):
    return backend_func(self.KX_over_K2, self.KY_over_K2, rot_fft)

"""


def __for_method__OperatorsPseudoSpectral2D__vecfft_from_divfft(self_KX_over_K2, self_KY_over_K2, div_fft):
    """Return the velocity in spectral space computed from the
        divergence."""
    ux_fft = -1j * self_KX_over_K2 * div_fft
    uy_fft = -1j * self_KY_over_K2 * div_fft
    return (ux_fft, uy_fft)


__code_new_method__OperatorsPseudoSpectral2D__vecfft_from_divfft = """

def new_method(self, div_fft):
    return backend_func(self.KX_over_K2, self.KY_over_K2, div_fft)

"""


def __for_method__OperatorsPseudoSpectral2D__gradfft_from_fft(self_KX, self_KY, f_fft):
    """Return the gradient of f_fft in spectral space."""
    px_f_fft = 1j * self_KX * f_fft
    py_f_fft = 1j * self_KY * f_fft
    return (px_f_fft, py_f_fft)


__code_new_method__OperatorsPseudoSpectral2D__gradfft_from_fft = """

def new_method(self, f_fft):
    return backend_func(self.KX, self.KY, f_fft)

"""


def __for_method__OperatorsPseudoSpectral2D__dealiasing_variable(self__has_to_dealiase, self_nK0_loc, self_nK1_loc, self_where_dealiased, f_fft):
    """Dealiasing a variable."""
    if self__has_to_dealiase:
        for iK0 in range(self_nK0_loc):
            for iK1 in range(self_nK1_loc):
                if self_where_dealiased[iK0, iK1]:
                    f_fft[iK0, iK1] = 0.0


__code_new_method__OperatorsPseudoSpectral2D__dealiasing_variable = """

def new_method(self, f_fft):
    return backend_func(self._has_to_dealiase, self.nK0_loc, self.nK1_loc, self.where_dealiased, f_fft)

"""

__transonic__ = ('0.6.1',)
